/* jedec2.h */

#ifndef __JEDEC2_H__
#define __JEDEC2_H__

#include "types2.h"

#define STX	0x02
#define ETX	0x03
#define LF	0x0a
#define CR	0x0d

typedef struct Jedec Jedec;
struct Jedec
{
	uint8_t	GALLogic[5808];		/* max. size of fuse matrix */
	uint8_t	GALXOR[10];		/* XOR bits */
	uint8_t	GALSig[64];		/* signature; 8 bytes */
	uint8_t	GALAC1[8];		/* AC1 bits */
	uint8_t	GALPT[64];		/* product term disable */
	uint8_t	GALSYN;			/* SYN bit */
	uint8_t	GALAC0;			/* AC0 bit */
	uint8_t	GALS1[10];		/* S1 bits for 22V10 */
};


uint16_t fileChecksum(uint8_t *aBuffer);
uint16_t numberOfFuses(uint16_t aGalType);
uint16_t fuseChecksum(struct JedecStruct *aJedec);
uint8_t *putString(uint8_t *aBuffer, const char *aString);
uint8_t *putLine(uint8_t *aBuffer, const char *aString);
uint8_t *putDecWord(uint8_t *aBuffer, uint16_t aValue);
uint8_t *putBits(uint8_t *aBuffer, uint8_t *aBits, uint16_t aAddress, uint16_t aLength, uint8_t aDefaultBit);
uint16_t pure(uint8_t *aBuffer, uint16_t aLength, uint8_t aValue);
void writeJedecFile(const char *aPathname, int aGalType, struct JedecStruct *aJedec, struct Config *aConfiguration);

#endif	/* __JEDEC2_H__ */
